#!/bin/bash

# 编译应用
echo "building..."

GOOS=linux GOARCH=amd64 go build -o sku3dweb-service

# 设置变量
IMAGE_NAME="registry.cn-chengdu.aliyuncs.com/infish/lymatweb"
VERSION="v1.1"

# 构建 Docker 镜像
echo "Building Docker image..."
docker build -t ${IMAGE_NAME}:${VERSION} .

# 推送镜像到仓库
echo "Pushing Docker image..."
docker push ${IMAGE_NAME}:${VERSION}

echo "Build and push completed successfully!"

# 删除编译的文件
rm -rf sku3dweb-service
