package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

const (
	USERTYPE_PERSONAL = 2
	USERTYPE_COMPANY  = 1
	SKU3D_USERID      = "61c2d599562300001a004978"
)

type Sass struct {
	Title  string
	Level  int32
	Status string //使用中

	Exp time.Time
}

type EnvTheme struct {
	Id         string           `bson:"id,omitempty" json:"id"`
	Options    *Evn3dOption     `bson:"options,omitempty" json:"options"`
	ToneMap    *ToneMap         `bson:"toneMap,omitempty" json:"toneMap"`
	Background *SceneBackground `bson:"background,omitempty" json:"background"`
}

type EditorSetting struct {
	Themes         []*EnvTheme `bson:"themes,omitempty" json:"themes"`
	ModelBaseColor *Vect3      `bson:"modelBaseColor,omitempty" json:"modelBaseColor"`
	DefaultEnv3dId string      `bson:"defaultEnv3dId,omitempty" json:"defaultEnv3dId"`
}

type User struct {
	Id       primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	UserType *int               `bson:"userType,omitempty" json:"userType,omitempty"` //2个人设计 1 企业设计师
	Phone    string             `bson:"phone,omitempty" json:"phone"`
	Password string             `bson:"password,omitempty" json:"password"`
	Name     string             `bson:"name,omitempty" json:"name"`
	Company  string             `bson:"company,omitempty" json:"company"`
	Wechat   string             `bson:"wechat,omitempty" json:"wechat"`
	City     string             `bson:"city,omitempty" json:"city"`
	Alipay   string             `bson:"alipay,omitempty" json:"alipay,omitempty"`
	Avatar   string             `bson:"avatar,omitempty" json:"avatar,omitempty"`

	Desc string `bson:"desc,omitempty" json:"desc"`

	CreateTime time.Time      `bson:"createTime,omitempty" json:"createTime,omitempty"`
	Email      string         `bson:"email" json:"email,omitempty"`
	LastLogin  time.Time      `bson:"lastLogin,omitempty" json:"lastLogin,omitempty"`
	Saas       *Sass          `bson:"saas,omitempty" json:"saas,omitempty"`
	EditorSet  *EditorSetting `bson:"editorSet,omitempty" json:"editorSet,omitempty"`

	Parent     string         `bson:"parent,omitempty" json:"parent,omitempty"` //主账号ID
	State      int32          `bson:"state,omitempty" json:"state,omitempty"`   //-1 用户已禁用
	Roles      []string       `bson:"roles,omitempty" json:"roles,omitempty"`
	Qiye       *QiyeInfo      `bson:"qiye,omitempty" json:"qiye,omitempty"` //企业信息
	IsPlatform *bool          `bson:"isPlatform" json:"isPlatform,omitempty"`
	TeamId     string         `bson:"teamId,omitempty" json:"teamId,omitempty"` //用户团队Id
	Cameras    []*SceneCamera `bson:"cameras,omitempty" json:"cameras"`         //用户的相机设置
}

type QiyeInfo struct {
	Name    string `bson:"name,omitempty" json:"name,omitempty"`       //名字
	Logo    string `bson:"logo,omitempty" json:"logo,omitempty"`       //logo
	Address string `bson:"address,omitempty" json:"address,omitempty"` //地址
}

func (u *User) GetID() string {
	return u.Id.Hex()
}

type SubAccount struct {
	Name       string    `bson:"name,omitempty" json:"name,omitempty"`
	Phone      string    `bson:"phone,omitempty" json:"phone,omitempty"`
	Password   string    `bson:"password,omitempty" json:"password,omitempty"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	LastLogin  time.Time `bson:"lastLogin,omitempty" json:"lastLogin,omitempty"`
	UserId     string    `bson:"userId,omitempty" json:"userId,omitempty"`
	RoleIds    []string  `bson:"roles,omitempty" json:"roles,omitempty"`   //用户角色
	TeamId     string    `bson:"teamId,omitempty" json:"teamId,omitempty"` //用户团队Id
}

type UserParent struct {
}

type Material1 struct {
	A    int
	Type int
}

type Material2 struct {
	B    int32
	Type int
}

type UserSetting struct {
	Id            primitive.ObjectID `bson:"_id,omitempty" json:"_id"`             //用户Id
	LoginName     string             `bson:"loginName,omitempty" json:"loginName"` //用户登录名字
	UserType      int                `bson:"userType,omitempty" json:"userType"`   //用户类型
	Avator        string             `bson:"avator,omitempty" json:"avator"`       //头像
	CreateTime    time.Time          `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime    time.Time          `bson:"updateTime,omitempty" json:"updateTime,omitempty"`
	LastLoginTime time.Time          `bson:"lastLoginTime,omitempty" json:"lastLoginTime"` //用户登录名字

	EditorSet  *EditorSetting `bson:"editorSet,omitempty" json:"editorSet,omitempty"`
	Cameras    []*SceneCamera `bson:"cameras,omitempty" json:"cameras"`                 //用户的相机设置
	EnableMall *bool          `bson:"enableMall,omitempty" json:"enableMall,omitempty"` //是否启用商城
}
