package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type InfoDesignScene struct {
	Name   string     `bson:"name,omitempty" json:"name"`
	Images []*OssType `bson:"images,omitempty" json:"images"`
}

//设计信息
type InfoDesign struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Thumbnail  *OssType           `bson:"thumbnail,omitempty" json:"thumbnail"`
	Name       string             `bson:"name,omitempty" json:"name"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`

	Scenes   []*InfoDesignScene `bson:"scenes,omitempty" json:"scenes"`
	UserId   primitive.ObjectID `bson:"userId,omitempty" json:"userId,omitempty"`
	DesignId string             `bson:"designId,omitempty" json:"designId,omitempty"`
	Sex      uint8              `bson:"sex,omitempty" json:"sex"`
	Season   uint8              `bson:"season,omitempty" json:"season"`
	Type     string             `bson:"type,omitempty" json:"type"`
	Pv       uint64             `bson:"pv,omitempty" json:"pv"`
	Weight   *int               `bson:"weight,omitempty" json:"weight"`
	IsPublic *bool              `bson:"isPublic,omitempty" json:"isPublic"`
}

//设计趋势
type InfoTrend struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Thumbnail  *OssType           `bson:"thumbnail,omitempty" json:"thumbnail"`
	Name       string             `bson:"name,omitempty" json:"name"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`

	Content string             `bson:"content,omitempty" json:"content"`
	UserId  primitive.ObjectID `bson:"userId,omitempty" json:"userId"`

	Sex      uint8  `bson:"sex,omitempty" json:"sex"`
	Season   uint8  `bson:"season,omitempty" json:"season"`
	Type     string `bson:"type,omitempty" json:"type"`
	Pv       uint64 `bson:"pv,omitempty" json:"pv"`
	IsPublic *bool  `bson:"isPublic,omitempty" json:"isPublic"`
}
